package tagrepository

import (
	"fmt"
	tagdomain "legalgo-BE-go/internal/domain/tag"

	"gorm.io/gorm/clause"
)

func (a *accessor) Update(spec tagdomain.Tag) error {
	if err := a.db.Clauses(clause.OnConflict{
		Columns: []clause.Column{{Name: "id"}},
		DoUpdates: clause.AssignmentColumns([]string{
			"name",
			"code",
			"updated_at",
		}),
	}).Select("name", "code", "updated_at").Save(&spec).Error; err != nil {
		return fmt.Errorf("failed to update tag: %v", err)
	}

	return nil
}
